library("gdata")
setwd("/home/abn/Escritorio/TFG-Estadística/Ejecuciones")
########################################################################
###########################  FUNCIONES #################################
########################################################################

Dibujar_grafo <- function(cx,cy,arcos){
  plot(cx,cy,type="n")
  text(cx,cy, labels = seq(1,length(cx),1),cex=.8)
  edges <- as.vector(t(which(arcos==1,arr.ind=TRUE)))
  for(i in seq(1,length(edges),2)){
    lines(c(cx[edges[i]],cx[edges[i+1]]),c(cy[edges[i]],cy[edges[i+1]]),type = "l",col="blue")
  }
}


Es_factible <- function(arcos,H,raiz){
  # Primero en profundidad desde el nodo raíz manteniendo un contador de saltos
  n_nodos <- length(arcos[1,])
  nodos_visitados <- rep(0,n_nodos)
  arcos_copia <- arcos
  # stack se tratará como una pila ( guarda los nodos a explorar)
  # hops se tratará como una pila ( guarda los saltos de los nodos a explorar)
  stack <- c(raiz)
  hops <- c(0)
  nodo_anterior <- 0
  while(length(stack)!=0){
    nodo_actual <- stack[length(stack)]
    #print(paste("Nodo actual: ",nodo_actual,sep=""))
    saltos_actuales <- hops[length(hops)]
    stack <- stack[-length(stack)]
    hops <- hops[-length(hops)]
    if(nodos_visitados[nodo_actual] == 0){
      nodos_visitados[nodo_actual] = 1
      for(i in which(arcos_copia[nodo_actual,]==1) ){
        stack<-c(stack,i)
        hops <-c(hops,saltos_actuales+1)
        # eliminamos el arco que acabamos de usar
        arcos_copia[nodo_actual,i] = 0
        arcos_copia[i,nodo_actual] = 0
        #########################################
        if((saltos_actuales+1)>H){
          # Más saltos que los permitidos
          #print("Más saltos que los permitidos")
          return(FALSE)
        }
      }
      # print("Stack ")
      # print(stack)
      # print("Hops ")
      # print(hops)
    }
    else{
      # Hay un ciclo
      #print("Hay un ciclo")
      return(FALSE)
    }
  }
  if(sum(nodos_visitados)<n_nodos){
    # Existen subciclos
    #print("Hay subciclos")
    return(FALSE)
  }
  #print("Todo correcto")
  return(TRUE)
}


get_CaminoySubtree <- function(arcos,raiz,nodo_obj){
  # Primero en profundidad desde el nodo objetivo
  n_nodos <- length(arcos[1,])
  nodos_visitados <- rep(0,n_nodos)
  nodos_visitados[raiz] <- 1
  arcos_copia <- arcos
  flag_break <- 0
  # stack se tratará como una pila ( guarda los nodos a explorar)
  solucion <- c()
  hijos <- c()
  stack <- c(nodo_obj)
  while(length(stack)!=0){
    nodo_actual <- stack[length(stack)]
    stack <- stack[-length(stack)]
    if(nodos_visitados[nodo_actual] == 0){
      solucion<-c(solucion,nodo_actual)
      nodos_visitados[nodo_actual] = 1
      n_hijos = 0
      flag_up = 0
      for(i in which(arcos[nodo_actual,]==1)){
        stack<-c(stack,i)
        n_hijos = n_hijos+1
        flag_up = 1
      }
    }
  }
  solucion<-c(solucion,raiz)
  return(solucion)
}

EW <- function(arcos,S1,SP1){
  final = 0
  n_puntos <- length(arcos[1,])
  # S1 y SP1
  copia_costes <- costes
  copia_costes[which(SP1==1)]=0
  copia_costes[which(S1==1)]=0
  
  savings <-array(NA,dim=c(n_puntos,n_puntos,n_puntos)) # NA significa que no es posible el cambio
  while(final==0){
    # Se puede mejorar el tiempo que tarda si no se recalculan todos los savings en cada paso
    
    #edges <- as.vector(t(which(arcos==1,arr.ind=TRUE)))
    for(i in  1:n_puntos){
      # Arco actual
      #punto1_1=edges[i]
      punto2_1=i
      # Cambio para reducir los tiempos
      ###############################################
      # Solo los que esten conectados a la raiz
      if(punto2_1 == raiz){next}
      if(arcos[punto2_1,raiz] != 1){next}
      # Buscamos el arco por el que cambiarlo
      
      
      
      ###############################################
      # Buscamos el arco por el que cambiarlo
      non_edges <- which(arcos==0,arr.ind=TRUE)
      # Quitamos los arcos de un nodo a si mismo
      non_edges <- non_edges[non_edges[,1]!=non_edges[,2],]
      subtree <- get_CaminoySubtree(arcos,raiz,punto2_1)
      #print(paste("Se evalua ",punto2_1,sep=""))
      non_edges <- non_edges[non_edges[,2] %in% subtree,] # <- que pertenezca al subárbol
      non_edges <- matrix(non_edges,nrow=length(non_edges)/2)
      if(length(non_edges) == 0){ next}
      non_edges <- non_edges[!(non_edges[,2] %in% raiz),]# <- pero no es la raiz
      non_edges <- matrix(non_edges,nrow=length(non_edges)/2)
      if(length(non_edges) == 0){ next}
      non_edges <- non_edges[!(non_edges[,1] %in% raiz),]# <- pero no es la raiz
      if(length(non_edges) == 0){ next}
      non_edges <- matrix(non_edges,nrow=length(non_edges)/2)
      if(length(non_edges)>0){
        for(j in  1:length(non_edges[,1])){
          punto1_2=non_edges[j,1]
          punto2_2=non_edges[j,2]
          if(is.na(savings[punto2_1,punto1_2,punto2_2])){
            #Probar que el cambio da una solución factible
            arcos[raiz,punto2_1] = 0
            arcos[punto2_1,raiz] = 0
            arcos[punto1_2,punto2_2] = 1
            arcos[punto2_2,punto1_2] = 1
            
            # Si es factible guardar ahorro
            if(Es_factible(arcos,H,raiz)){
              #print(paste("Arco (",punto1_1,",",punto2_1,") por (",punto1_2,",",punto2_1,")",sep = ""))
              savings[punto2_1,punto1_2,punto2_2] <- copia_costes[raiz,punto2_1] - copia_costes[punto1_2,punto2_2]
              #print(paste("Ahorro = ",savings[punto1_1,punto2_1,punto1_2], sep=""))
            }
            
            # Revertir el cambio
            arcos[raiz,punto2_1] = 1
            arcos[punto2_1,raiz] = 1
            arcos[punto1_2,punto2_2] = 0
            arcos[punto2_2,punto1_2] = 0
          }
        }
      }
    }
    # Tenemos en savings los ahorros calculados
    # Encontrar los tamRCL-ésimos mejores ahorros
    max_savings = c()
    cambio_i <- c()
    cambio_j <- c()
    cambio_k <- c()
    for(i in 1:n_puntos){
      for(j in 1:n_puntos){
        for(k in 1:n_puntos){
          if(length(max_savings)<1){
            if(!is.na(savings[i,j,k]) && savings[i,j,k]>0){
              max_savings <- c(max_savings,savings[i,j,k])
              cambio_i <- c(cambio_i,i)
              cambio_j <- c(cambio_j,j)
              cambio_k <- c(cambio_k,k)
            }
          }
          if(length(max_savings)==1 && isTRUE(savings[i,j,k]>min(max_savings))){
            posicion = which(max_savings == min(max_savings))
            max_savings[posicion] <- savings[i,j,k]
            cambio_i[posicion] <- i
            cambio_j[posicion] <- j
            cambio_k[posicion] <- k
          }
        }
      }
    }
    
    flagbreak = 1
    if(isTRUE(max_savings[1] > 0) ){
      # Hay mejora
      flagbreak = 0
    }
    
    if(flagbreak == 1) {break;}
    
    
    
    #print(paste("Arco (",punto1_1,",",punto2_1,") por (",punto1_2,",",punto2_1,")",sep = ""))
    
    #print("SAVINGS")
    #print(savings[25,3,1])
    #print("MAX-SAVINGS")
    #print(max_savings)
    
    eleccion = length(max_savings)+1
    while(eleccion == length(max_savings)+1){
      eleccion = trunc(runif(1,1,length(max_savings)+1))
    }
    #print(paste("Arco (",punto1_1,",",punto2_1,") por (",punto1_2,",",punto2_1,")",sep = ""))
    
    arcos[raiz,cambio_i[eleccion]] = 0
    arcos[cambio_i[eleccion],raiz] = 0
    arcos[cambio_j[eleccion],cambio_k[eleccion]] = 1
    arcos[cambio_k[eleccion],cambio_j[eleccion]] = 1
    
    #Dibujar_grafo(cx,cy,arcos)
    
    #Se marcan los savings que desaparecen o han de ser actualizados
    
    actualizantes <- get_CaminoySubtree(arcos,raiz,cambio_j[eleccion])
    savings[,actualizantes,] = NA
    savings[,,actualizantes] = NA
    savings[actualizantes,,] = NA
    
  }
  return(arcos)
}

join4 <- function(primera_solucion,arcos){# arcos es la solución de partidad cada ves (aqui la estrella)
  SP1<- matrix (0,n_puntos,n_puntos)
  S1 <- matrix (0,n_puntos,n_puntos)
  solucion_actual <- primera_solucion
  coste_actual <- sum(costes[which(primera_solucion==1)])/2
  A1 <- c()
  flag = 0
  while(flag==0){
    flag=1
    
    # Se fuerzan unicamente los 4 arcos con menor coste incidentes a cada nodo
    csa <- solucion_actual
    csa[which(csa==1)] = -1
    for(i in 1:n_puntos){
      candidatos<-which(csa[i,] == 0)
      candidatos<-candidatos[-which(candidatos==i)]
      if(length(candidatos)>0){
        for(j in 1:min(c(4,length(candidatos)))){
          #print(j)
          #print(candidatos)
          forzar <- which(costes[candidatos] == min(costes[candidatos] ))
          #print("Costes")
          #print(costes[candidatos])
          #print(paste("Se escoge ",forzar,sep=""))
          csa[i,candidatos[forzar]] = 1
          candidatos = candidatos [-forzar]
        }
      }
    }
    csa[which(csa==-1)] = 0
    
    indices <-  unique(which(csa==1,arr.ind = TRUE))
    if(length(which((indices[,1]==indices[,2])))>0){
      indices <- indices[-which((indices[,1]==indices[,2])),]
    }
    
    for(i in 1:(length(indices[,1]))){# Por cada arco en los indices
      S1 <- matrix (0,n_puntos,n_puntos)
      # inhibir el arco
      S1[indices[i,1],indices[i,2]] <- 1
      S1 <- t(S1)
      S1[indices[i,1],indices[i,2]] <- 1
      solucion_interna <- EW(arcos,S1,SP1)
      #Dibujar_grafo(cx,cy,solucion_interna)
      coste <- sum(costes[which(solucion_interna==1)])/2
      if(coste < coste_actual){
        flag = 0 # Ha habido alguna mejora
        coste_actual <- coste
        solucion_actual <- solucion_interna
        A1 <- S1
        print(paste("Coste = ",coste,sep=""))
      }
    }
    if(flag == 0){
      SP1[which(A1==1)]=1
    }
    #Dibujar_grafo(cx,cy,solucion_actual)
  }
  
  newList <- list("arcos" = solucion_actual, "forc" = SP1)
  return(newList)
}








##############################################################################
##############################################################################
problemas<- read.csv("ejecuciones_red3.txt",header = TRUE)
problemas <- problemas[1:4]


cat("archivo,problema,raiz,H,solución,tiempo,centralidad_modificada,\n",file="Join4/output.txt")

for(w in 1:length(problemas[,1])){
  print(problemas[w,])
  archivo = toString(problemas[w,1])
  problema = problemas[w,2] 
  raiz = problemas[w,3]
  H = problemas[w,4]
  # Datos por linea (Cada linea es un elemento del vector y son string)
# Datos por linea (Cada linea es un elemento del vector y son string)
raw_data<-readLines(archivo,encoding="UTF-8")


f1 <- function(x) unlist(strsplit(trim(x)," "))
options(digits=7)
# Datos por elemento (Cada número es un elemento del vector y son doubles)
vector_data<-as.double(unlist(lapply(raw_data,f1)))

n_problemas <- vector_data[1]
vector_data <- vector_data[-1]
indice=1
cx<-c(); cy<-c()
for(i in 1:n_problemas){
  n_puntos <- vector_data[indice]
  if(i == problema ){
    for(j in seq(1,2*n_puntos,2)){
      cx<-c(cx,vector_data[indice+j])
      cy<-c(cy,vector_data[indice+j+1])
    }
    break;
  }
  indice = indice + n_puntos*2 +1
}
costes <- as.matrix(dist(cbind(cx,cy)))

# Coordenadas del problema escogido en:        cx cy
# Costes en forma de distancia euclidea en:    costes

# Centralidad midificada de la raiz
centralidades <-c()
for (i in 1:length(costes[,1])){
  centralidades <-c(centralidades,1/sum(costes[i,]))
}
nodomax <- which(centralidades == max(centralidades))
nodomin <- which(centralidades == min(centralidades))
centralidadm <- (centralidades[raiz] - centralidades[nodomin])/(centralidades[nodomax]-centralidades[nodomin])


# Second Order Algorithm I1 + Essau Williams
# Determining Hop-Constrained Spanning Trees with Repetitive Heuristics 2007
# Manuela Fernandes Stefan Voss Luis Gouveia

# arcs[i,j] =  1 si existe el arco si no = 0
arcos <- matrix (0,n_puntos,n_puntos)
# Solución inicial en forma de estrella
arcos[raiz,(1:n_puntos)[-raiz]]=1
arcos[(1:n_puntos)[-raiz],raiz]=1
#Eliminación simple de los arcos (i,j) cuyo coste(i,j)>=coste(raiz,j)
for(i in 1:n_puntos){
  if(i!=raiz){
    for(j in 1:n_puntos){
      if(j!=raiz){
        if(costes[i,j]>=costes[raiz,j]){
          arcos[i,j]=-1
          arcos[j,i]=-1
        }
      }
    }
  }
}


SP1<- matrix (0,n_puntos,n_puntos)
S1 <- matrix (0,n_puntos,n_puntos)
primera_solucion <- EW(arcos,S1,SP1)
solucion_actual <- primera_solucion
coste_actual <- sum(costes[which(solucion_actual==1)])/2
#Dibujar_grafo(cx,cy,solucion_actual)
# En arcos siempre está la solución en estrella
ptm <- proc.time()
solucion_actual<-join4(solucion_actual,arcos)
endtime <- proc.time() - ptm

coste_final <- sum(costes[which(solucion_actual$arcos==1)])/2

arch <- strsplit(archivo, NULL)[[1]]
arch<- paste(rev(arch),collapse = "")
arch <- substr(arch,5,nchar(arch))
arch <- strsplit(arch, NULL)[[1]]
arch<- paste(rev(arch),collapse = "")

print(paste("Coste ",coste_final,sep=""))


fichero <- paste("Join4/",arch,"_",problema,"_",raiz,"_",H,".png",sep="")
png(filename=fichero)
Dibujar_grafo(cx,cy,solucion_actual$arcos)
dev.off()


fichero <- paste("Join4/",arch,"_",problema,"_",raiz,"_",H,"_v2.png",sep="")
png(filename=fichero)
Dibujar_grafo(cx,cy,solucion_actual$arcos)
edges<-as.vector(t(which(solucion_actual$forc==1,arr.ind = TRUE)))
if(length(edges)>0){
  for(i in seq(1,length(edges),2)){
    lines(c(cx[edges[i]],cx[edges[i+1]]),c(cy[edges[i]],cy[edges[i+1]]),type = "l",lty = 4,col="red")
  }
}
dev.off()

cat(paste(archivo,",",problema,",",raiz,",",H,",",round(coste_final,3),",",round(endtime[3],3),",",round(centralidadm,3),"\n",sep=""),file="Join4/output.txt",append = TRUE)


}